
-- example stored package with parameters

CREATE OR REPLACE PACKAGE BODY manage_students 
AS 
	PROCEDURE FIND_NAME( ID IN NUMBER,  LNAME OUT  VARCHAR2,  
	FNAME OUT VARCHAR2)
	IS
	BEGIN
		SELECT last_name, first_name
		INTO LNAME, FNAME
		FROM student 
		WHERE student_id = ID; 
	EXCEPTION
		WHEN OTHERS
		THEN
		DBMS_OUTPUT.PUT_LINE(' Student id not found ');
	END FIND_NAME;

-- the second function in the package is next.

	FUNCTION Show_description(i_course_no NUMBER)
	RETURN VARCHAR2
	IS
	v_description VARCHAR2(50);
	BEGIN
	SELECT description
	INTO v_description
	FROM course
	WHERE course_no = i_course_no;
	RETURN v_description;
	EXCEPTION
	WHEN NO_DATA_FOUND
	THEN
	RETURN ('The cursor is not in the database');
	
	WHEN OTHERS
	THEN
	RETURN ('Error in running show_description');
	END Show_description;	

-- third function in the package is next

	FUNCTION id_is_good(i_student_id NUMBER) 
	RETURN BOOLEAN 
	IS
	v_id_cnt NUMBER;
	BEGIN
	SELECT count(*) 
	INTO v_id_cnt 
	FROM student 
	WHERE student_id = i_student_id; 
	RETURN v_id_cnt=1;
	EXCEPTION
	WHEN OTHERS 
	THEN
		RETURN FALSE; 
	END id_is_good;


END manage_students;
/
