-- showing use of after update trigger
-- this trigger fires when the zip code of a student is modified 
-- from the old one.

CREATE OR REPLACE TRIGGER student_au
BEFORE UPDATE ON student 
FOR EACH ROW
WHEN (NVL(NEW.ZIP, ' ') <> OLD.ZIP)
BEGIN
	UPDATE STUDENT 
	   SET ZIP = :NEW.ZIP 
	WHERE ZIP = :OLD.ZIP;
	
	IF SQL%NOTFOUND
	 THEN DBMS_OUTPUT.PUT_LINE('STUDENT NOT AVAILABLE');
	END IF;

END;
/
