-- example declaration of a Trigger 

CREATE OR REPLACE TRIGGER instructor_aud
      BEFORE UPDATE OR DELETE ON INSTRUCTOR
      DECLARE
	v_type VARCHAR2(10);
	 -- UPDATING BOOLEAN := TRUE;
	-- DELETING BOOLEAN := FALSE;

      BEGIN
	IF UPDATING
	THEN
		v_type := 'UPDATE';
	ELSIF DELETING
	THEN
		v_type := 'DELETE';
	END IF;
	UPDATE statistics
	SET transaction_user = USER, 
	        transaction_date = SYSDATE
	WHERE table_name = 'INSTRUCTOR'
	        AND  transaction_name = v_type;
	IF SQL % NOTFOUND
	THEN
		INSERT INTO statistics
		VALUES ('INSTRUCTOR', v_type, USER, SYSDATE);
	END IF;
END;	
/
